module AuthActivity
  class AuthEvent < ApplicationRecord
    belongs_to :trackable, optional: true, polymorphic: true

    enum action_type: {
      failed_login: 0,
      succesful_login: 1,
      attributes_changed: 2,
      failed_password_request: 3,
      succesful_password_request: 4,
      user_created: 5,
      user_destroyed: 6,
      logout: 7
    }

    before_save :set_ip_address

    private

    def set_ip_address
      metadata[:ip_address] = AuthActivity::Current.ip_address
      metadata[:user_agent] = AuthActivity::Current.user_agent
      metadata[:request_id] = AuthActivity::Current.request_id
    end
  end
end
